<?php if (!defined('VSF_BLOCK_DIR')) die("Denied");

include_once('vsf_simple_block_setup.php');

/** Simple filter object */
class VSFSimpleBlockRules
{
	public static $RULES_QUANTITY = "quantity";
	public static $RULES_RULES = "rules";
	
	protected $quantity;
	protected $rules;
	
	/** Null constructor */
	function __construct()
    {
        $a = func_get_args();
        $i = func_num_args();
        if ( method_exists($this, $f = '__construct' . $i) )
		{
            call_user_func_array( array($this, $f), $a );
        }
    }
   
    /** Full constructor */
	function __construct2($quantityValue, $rulesValue)
    {
        $this->quantity = $quantityValue;
		$this->rules = $rulesValue;
    }
	
	/** Getter */
	public function getRules() { return $this->rules; }
	/** Getter */
	public function getQuantity() { return $this->quantity; }
	
	public function addRuleToXML($xmlObject)
	{
		$xmlObject->addChild(self::$RULES_QUANTITY, $this->quantity);
		$rules = $xmlObject->addChild(self::$RULES_RULES);
		
		foreach($this->rules as $rule)
		{
			$rule->addRuleToXML($rules);
		}
		
		return $xmlObject;
	}
	
	public function constructRulesFromXMLObject($xmlObject)
	{
		$rulesNodes = $xmlObject->children();
		
		// first node is quantity,
		// second is rules which is an array
		$x = 0;
		foreach($rulesNodes as $name => $value)
		{
			//echo "node name: " . $name . " node value: " . $value . "<br />";
			if( $x == 0 )
			{
				if( $name !== self::$RULES_QUANTITY ) die (__("The quantity node is not correct", VSF_BLOCK_DOMAIN));
				$this->quantity = $value;
			}
			else
			{
				if( $name !== self::$RULES_RULES ) die (__("The rules node is not correct", VSF_BLOCK_DOMAIN));
				$tempRulesChildren = $value->children();
				
				$this->rules = array();
				
				foreach($tempRulesChildren as $ruleInstanceName => $ruleInstanceValue)
				{
					if( $ruleInstanceName !== VSFSimpleBlockRule::$RULE ) die (__("The rule instance node is not correct", VSF_BLOCK_DOMAIN));
					$ruleInstanceChildren = $ruleInstanceValue->children();
					
					$vsfSimpleBlockRule = new VSFSimpleBlockRule();
					$vsfSimpleBlockRule->constructRuleFromXMLObject($ruleInstanceChildren);
					VSFBlockEssentials::log("completed rule object: " . $vsfSimpleBlockRule);
					array_push($this->rules, $vsfSimpleBlockRule);
				}
			}
			
			$x++;
		}
	}
	
	/** Default toString */
	public function __toString() 
	{
		$output = 'Rules Object: [quantity: ' . $this->quantity . ', rules: ';
		
		foreach ( $this->rules as $ruleInstance )
		{
			$output .= $ruleInstance;
		}
		
		$output .= ']<br />';
		
		return $output;
	}
}

?>